package net.sf.itcb.common.web.vaadin.component.impl;


import net.sf.itcb.common.web.vaadin.component.ItcbPage;
import net.sf.itcb.common.web.vaadin.page.PageMappingProcessor;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.vaadin.ui.VerticalLayout;

/**
 * Each page has to extend this class
 * 
 * @author Pierre Le Roux
 *
 */
public abstract class AbstractItcbPage extends VerticalLayout implements ItcbPage {

	private static final long serialVersionUID = 1L;

	private PageMappingProcessor pageMappingProcessor;
	
	protected final Logger log = LoggerFactory.getLogger(getClass());
		
	public PageMappingProcessor getPageMappingProcessor() {
		return pageMappingProcessor;
	}
	
	public void init() throws Exception {
		if(log.isDebugEnabled()) {
			log.debug("Initializing {}", getClass());
		}
		setMargin(false);
		setSpacing(false);
		defineContentDelegate();
	}
	
	protected abstract void defineContentDelegate() throws Exception;

	public void setPageMappingProcessor(
			PageMappingProcessor pageMappingProcessor) {
		this.pageMappingProcessor = pageMappingProcessor;
	}
		
	

	   	
}

